<?php namespace Application\Block\BdpLinkTest;

defined("C5_EXECUTE") or die("Access Denied.");

use Concrete\Core\Block\BlockController;
use Core;
use Database;
use Page;
use AssetList;

class Controller extends BlockController
{
    public $helpers = array('form');
    public $btFieldsRequired = array('large' => array(), 'medium' => array(), 'small' => array());
    protected $btExportFileColumns = array();
    protected $btExportPageColumns = array('linkL', 'linkM', 'linkS');
    protected $btExportTables = array('btBdpLinkTest', 'btBdpLinkTestLargeEntries', 'btBdpLinkTestMediumEntries', 'btBdpLinkTestSmallEntries');
    protected $btTable = 'btBdpLinkTest';
    protected $btInterfaceWidth = 400;
    protected $btInterfaceHeight = 500;
    protected $btIgnorePageThemeGridFrameworkContainer = false;
    protected $btCacheBlockRecord = true;
    protected $btCacheBlockOutput = true;
    protected $btCacheBlockOutputOnPost = true;
    protected $btCacheBlockOutputForRegisteredUsers = true;
    protected $btCacheBlockOutputLifetime = 0;
    protected $btDefaultSet = 'navigation';
    protected $pkg = false;
    
    public function getBlockTypeDescription()
    {
        return t("");
    }

    public function getBlockTypeName()
    {
        return t("Page link test");
    }

    public function view()
    {
        $db = Database::connection();
        $large = array();
        $large_items = $db->fetchAll('SELECT * FROM btBdpLinkTestLargeEntries WHERE bID = ? ORDER BY sortOrder', array($this->bID));
        $this->set('large_items', $large_items);
        $this->set('large', $large);
        $medium = array();
        $medium_items = $db->fetchAll('SELECT * FROM btBdpLinkTestMediumEntries WHERE bID = ? ORDER BY sortOrder', array($this->bID));
        $this->set('medium_items', $medium_items);
        $this->set('medium', $medium);
        $small = array();
        $small_items = $db->fetchAll('SELECT * FROM btBdpLinkTestSmallEntries WHERE bID = ? ORDER BY sortOrder', array($this->bID));
        $this->set('small_items', $small_items);
        $this->set('small', $small);
    }

    public function delete()
    {
        $db = Database::connection();
        $db->delete('btBdpLinkTestLargeEntries', array('bID' => $this->bID));
        $db->delete('btBdpLinkTestMediumEntries', array('bID' => $this->bID));
        $db->delete('btBdpLinkTestSmallEntries', array('bID' => $this->bID));
        parent::delete();
    }

    public function duplicate($newBID)
    {
        $db = Database::connection();
        $large_items = $db->fetchAll('SELECT * FROM btBdpLinkTestLargeEntries WHERE bID = ? ORDER BY sortOrder', array($this->bID));
        foreach ($large_items as $large_item) {
            unset($large_item['id']);
            $large_item['bID'] = $newBID;
            $db->insert('btBdpLinkTestLargeEntries', $large_item);
        }
        $medium_items = $db->fetchAll('SELECT * FROM btBdpLinkTestMediumEntries WHERE bID = ? ORDER BY sortOrder', array($this->bID));
        foreach ($medium_items as $medium_item) {
            unset($medium_item['id']);
            $medium_item['bID'] = $newBID;
            $db->insert('btBdpLinkTestMediumEntries', $medium_item);
        }
        $small_items = $db->fetchAll('SELECT * FROM btBdpLinkTestSmallEntries WHERE bID = ? ORDER BY sortOrder', array($this->bID));
        foreach ($small_items as $small_item) {
            unset($small_item['id']);
            $small_item['bID'] = $newBID;
            $db->insert('btBdpLinkTestSmallEntries', $small_item);
        }
        parent::duplicate($newBID);
    }

    public function add()
    {
        $this->addEdit();
        $large = $this->get('large');
        $this->set('large_items', array());
        $this->set('large', $large);
        $medium = $this->get('medium');
        $this->set('medium_items', array());
        $this->set('medium', $medium);
        $small = $this->get('small');
        $this->set('small_items', array());
        $this->set('small', $small);
    }

    public function edit()
    {
        $db = Database::connection();
        $this->addEdit();
        $large = $this->get('large');
        $large_items = $db->fetchAll('SELECT * FROM btBdpLinkTestLargeEntries WHERE bID = ? ORDER BY sortOrder', array($this->bID));
        $this->set('large', $large);
        $this->set('large_items', $large_items);
        $medium = $this->get('medium');
        $medium_items = $db->fetchAll('SELECT * FROM btBdpLinkTestMediumEntries WHERE bID = ? ORDER BY sortOrder', array($this->bID));
        $this->set('medium', $medium);
        $this->set('medium_items', $medium_items);
        $small = $this->get('small');
        $small_items = $db->fetchAll('SELECT * FROM btBdpLinkTestSmallEntries WHERE bID = ? ORDER BY sortOrder', array($this->bID));
        $this->set('small', $small);
        $this->set('small_items', $small_items);
    }

    protected function addEdit()
    {
        $large = array();
        $this->set('large', $large);
        $this->set('identifier', new \Concrete\Core\Utility\Service\Identifier());
        $medium = array();
        $this->set('medium', $medium);
        $small = array();
        $this->set('small', $small);
        $al = AssetList::getInstance();
        $al->register('css', 'repeatable-ft.form', 'blocks/bdp_link_test/css_form/repeatable-ft.form.css', array(), $this->pkg);
        $al->register('javascript', 'handlebars', 'blocks/bdp_link_test/js_form/handlebars-v4.0.4.js', array(), $this->pkg);
        $al->register('javascript', 'handlebars-helpers', 'blocks/bdp_link_test/js_form/handlebars-helpers.js', array(), $this->pkg);
        $this->requireAsset('core/sitemap');
        $this->requireAsset('css', 'repeatable-ft.form');
        $this->requireAsset('javascript', 'handlebars');
        $this->requireAsset('javascript', 'handlebars-helpers');
        $this->set('btFieldsRequired', $this->btFieldsRequired);
        $this->set('identifier_getString', Core::make('helper/validation/identifier')->getString(18));
    }

    public function save($args)
    {
        $db = Database::connection();
        $rows = $db->fetchAll('SELECT * FROM btBdpLinkTestLargeEntries WHERE bID = ? ORDER BY sortOrder', array($this->bID));
        $large_items = isset($args['large']) && is_array($args['large']) ? $args['large'] : array();
        $queries = array();
        if (!empty($large_items)) {
            $i = 0;
            foreach ($large_items as $large_item) {
                $data = array(
                    'sortOrder' => $i + 1,
                );
                if (isset($large_item['linkL']) && trim($large_item['linkL']) != '' && (($large_item['linkL_c'] = Page::getByID($large_item['linkL'])) && !$large_item['linkL_c']->error)) {
                    $data['linkL'] = trim($large_item['linkL']);
                } else {
                    $data['linkL'] = null;
                }
                if (isset($rows[$i])) {
                    $queries['update'][$rows[$i]['id']] = $data;
                    unset($rows[$i]);
                } else {
                    $data['bID'] = $this->bID;
                    $queries['insert'][] = $data;
                }
                $i++;
            }
        }
        if (!empty($rows)) {
            foreach ($rows as $row) {
                $queries['delete'][] = $row['id'];
            }
        }
        if (!empty($queries)) {
            foreach ($queries as $type => $values) {
                if (!empty($values)) {
                    switch ($type) {
                        case 'update':
                            foreach ($values as $id => $data) {
                                $db->update('btBdpLinkTestLargeEntries', $data, array('id' => $id));
                            }
                            break;
                        case 'insert':
                            foreach ($values as $data) {
                                $db->insert('btBdpLinkTestLargeEntries', $data);
                            }
                            break;
                        case 'delete':
                            foreach ($values as $value) {
                                $db->delete('btBdpLinkTestLargeEntries', array('id' => $value));
                            }
                            break;
                    }
                }
            }
        }
        $rows = $db->fetchAll('SELECT * FROM btBdpLinkTestMediumEntries WHERE bID = ? ORDER BY sortOrder', array($this->bID));
        $medium_items = isset($args['medium']) && is_array($args['medium']) ? $args['medium'] : array();
        $queries = array();
        if (!empty($medium_items)) {
            $i = 0;
            foreach ($medium_items as $medium_item) {
                $data = array(
                    'sortOrder' => $i + 1,
                );
                if (isset($medium_item['linkM']) && trim($medium_item['linkM']) != '' && (($medium_item['linkM_c'] = Page::getByID($medium_item['linkM'])) && !$medium_item['linkM_c']->error)) {
                    $data['linkM'] = trim($medium_item['linkM']);
                } else {
                    $data['linkM'] = null;
                }
                if (isset($rows[$i])) {
                    $queries['update'][$rows[$i]['id']] = $data;
                    unset($rows[$i]);
                } else {
                    $data['bID'] = $this->bID;
                    $queries['insert'][] = $data;
                }
                $i++;
            }
        }
        if (!empty($rows)) {
            foreach ($rows as $row) {
                $queries['delete'][] = $row['id'];
            }
        }
        if (!empty($queries)) {
            foreach ($queries as $type => $values) {
                if (!empty($values)) {
                    switch ($type) {
                        case 'update':
                            foreach ($values as $id => $data) {
                                $db->update('btBdpLinkTestMediumEntries', $data, array('id' => $id));
                            }
                            break;
                        case 'insert':
                            foreach ($values as $data) {
                                $db->insert('btBdpLinkTestMediumEntries', $data);
                            }
                            break;
                        case 'delete':
                            foreach ($values as $value) {
                                $db->delete('btBdpLinkTestMediumEntries', array('id' => $value));
                            }
                            break;
                    }
                }
            }
        }
        $rows = $db->fetchAll('SELECT * FROM btBdpLinkTestSmallEntries WHERE bID = ? ORDER BY sortOrder', array($this->bID));
        $small_items = isset($args['small']) && is_array($args['small']) ? $args['small'] : array();
        $queries = array();
        if (!empty($small_items)) {
            $i = 0;
            foreach ($small_items as $small_item) {
                $data = array(
                    'sortOrder' => $i + 1,
                );
                if (isset($small_item['linkS']) && trim($small_item['linkS']) != '' && (($small_item['linkS_c'] = Page::getByID($small_item['linkS'])) && !$small_item['linkS_c']->error)) {
                    $data['linkS'] = trim($small_item['linkS']);
                } else {
                    $data['linkS'] = null;
                }
                if (isset($rows[$i])) {
                    $queries['update'][$rows[$i]['id']] = $data;
                    unset($rows[$i]);
                } else {
                    $data['bID'] = $this->bID;
                    $queries['insert'][] = $data;
                }
                $i++;
            }
        }
        if (!empty($rows)) {
            foreach ($rows as $row) {
                $queries['delete'][] = $row['id'];
            }
        }
        if (!empty($queries)) {
            foreach ($queries as $type => $values) {
                if (!empty($values)) {
                    switch ($type) {
                        case 'update':
                            foreach ($values as $id => $data) {
                                $db->update('btBdpLinkTestSmallEntries', $data, array('id' => $id));
                            }
                            break;
                        case 'insert':
                            foreach ($values as $data) {
                                $db->insert('btBdpLinkTestSmallEntries', $data);
                            }
                            break;
                        case 'delete':
                            foreach ($values as $value) {
                                $db->delete('btBdpLinkTestSmallEntries', array('id' => $value));
                            }
                            break;
                    }
                }
            }
        }
        parent::save($args);
    }

    public function validate($args)
    {
        $e = Core::make("helper/validation/error");
        $largeEntriesMin = 0;
        $largeEntriesMax = 2;
        $largeEntriesErrors = 0;
        $large = array();
        if (isset($args['large']) && is_array($args['large']) && !empty($args['large'])) {
            if ($largeEntriesMin >= 1 && count($args['large']) < $largeEntriesMin) {
                $e->add(t("The %s field requires at least %s entries, %s entered.", t("Large link"), $largeEntriesMin, count($args['large'])));
                $largeEntriesErrors++;
            }
            if ($largeEntriesMax >= 1 && count($args['large']) > $largeEntriesMax) {
                $e->add(t("The %s field is set to a maximum of %s entries, %s entered.", t("Large link"), $largeEntriesMax, count($args['large'])));
                $largeEntriesErrors++;
            }
            if ($largeEntriesErrors == 0) {
                foreach ($args['large'] as $large_k => $large_v) {
                    if (is_array($large_v)) {
                        if ((in_array("linkL", $this->btFieldsRequired['large']) || (isset($large_v['linkL']) && trim($large_v['linkL']) != '0')) && (trim($large_v['linkL']) == "" || (($page = Page::getByID($large_v['linkL'])) && $page->error !== false))) {
                            $e->add(t("The %s field is required (%s, row #%s).", t("link"), t("Large link"), $large_k));
                        }
                    } else {
                        $e->add(t("The values for the %s field, row #%s, are incomplete.", t('Large link'), $large_k));
                    }
                }
            }
        } else {
            if ($largeEntriesMin >= 1) {
                $e->add(t("The %s field requires at least %s entries, none entered.", t("Large link"), $largeEntriesMin));
            }
        }
        $mediumEntriesMin = 0;
        $mediumEntriesMax = 3;
        $mediumEntriesErrors = 0;
        $medium = array();
        if (isset($args['medium']) && is_array($args['medium']) && !empty($args['medium'])) {
            if ($mediumEntriesMin >= 1 && count($args['medium']) < $mediumEntriesMin) {
                $e->add(t("The %s field requires at least %s entries, %s entered.", t("Medium link"), $mediumEntriesMin, count($args['medium'])));
                $mediumEntriesErrors++;
            }
            if ($mediumEntriesMax >= 1 && count($args['medium']) > $mediumEntriesMax) {
                $e->add(t("The %s field is set to a maximum of %s entries, %s entered.", t("Medium link"), $mediumEntriesMax, count($args['medium'])));
                $mediumEntriesErrors++;
            }
            if ($mediumEntriesErrors == 0) {
                foreach ($args['medium'] as $medium_k => $medium_v) {
                    if (is_array($medium_v)) {
                        if ((in_array("linkM", $this->btFieldsRequired['medium']) || (isset($medium_v['linkM']) && trim($medium_v['linkM']) != '0')) && (trim($medium_v['linkM']) == "" || (($page = Page::getByID($medium_v['linkM'])) && $page->error !== false))) {
                            $e->add(t("The %s field is required (%s, row #%s).", t("link"), t("Medium link"), $medium_k));
                        }
                    } else {
                        $e->add(t("The values for the %s field, row #%s, are incomplete.", t('Medium link'), $medium_k));
                    }
                }
            }
        } else {
            if ($mediumEntriesMin >= 1) {
                $e->add(t("The %s field requires at least %s entries, none entered.", t("Medium link"), $mediumEntriesMin));
            }
        }
        $smallEntriesMin = 0;
        $smallEntriesMax = 5;
        $smallEntriesErrors = 0;
        $small = array();
        if (isset($args['small']) && is_array($args['small']) && !empty($args['small'])) {
            if ($smallEntriesMin >= 1 && count($args['small']) < $smallEntriesMin) {
                $e->add(t("The %s field requires at least %s entries, %s entered.", t("Small link"), $smallEntriesMin, count($args['small'])));
                $smallEntriesErrors++;
            }
            if ($smallEntriesMax >= 1 && count($args['small']) > $smallEntriesMax) {
                $e->add(t("The %s field is set to a maximum of %s entries, %s entered.", t("Small link"), $smallEntriesMax, count($args['small'])));
                $smallEntriesErrors++;
            }
            if ($smallEntriesErrors == 0) {
                foreach ($args['small'] as $small_k => $small_v) {
                    if (is_array($small_v)) {
                        if ((in_array("linkS", $this->btFieldsRequired['small']) || (isset($small_v['linkS']) && trim($small_v['linkS']) != '0')) && (trim($small_v['linkS']) == "" || (($page = Page::getByID($small_v['linkS'])) && $page->error !== false))) {
                            $e->add(t("The %s field is required (%s, row #%s).", t("link"), t("Small link"), $small_k));
                        }
                    } else {
                        $e->add(t("The values for the %s field, row #%s, are incomplete.", t('Small link'), $small_k));
                    }
                }
            }
        } else {
            if ($smallEntriesMin >= 1) {
                $e->add(t("The %s field requires at least %s entries, none entered.", t("Small link"), $smallEntriesMin));
            }
        }
        return $e;
    }

    public function composer()
    {
        $al = AssetList::getInstance();
        $al->register('javascript', 'auto-js-bdp_link_test', 'blocks/bdp_link_test/auto.js', array(), $this->pkg);
        $this->requireAsset('javascript', 'auto-js-bdp_link_test');
        $this->edit();
    }
}